import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { DialogComponent } from './components/dialog/dialog.component';
import { FamilyComponent } from './components/family/family.component';
import {HomeComponent} from './components/home/home.component';
import { ResultComponent } from './components/result/result.component';

const routes: Routes = [
  {
    path: '',
    component: HomeComponent,
  },
  {
    path: 'family/:id',
    component: FamilyComponent,
  },
  {
    path: 'result/:family/:id',
    component: ResultComponent,
  },
  {
    path: 'dialog',
    component: DialogComponent,
  }
];

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  exports: [RouterModule]
})
export class AppRoutingModule { }
