import { APP_INITIALIZER, NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { HttpClientModule } from '@angular/common/http';
import { FamilyComponent } from './components/family/family.component';
import { HomeComponent } from './components/home/home.component';
import { ResultComponent } from './components/result/result.component';
import { DialogComponent} from './components/dialog/dialog.component';
import { MatDialogModule } from '@angular/material/dialog';
import { DataService } from './services/data.service';


@NgModule({
  declarations: [
    AppComponent,
    HomeComponent,
    FamilyComponent,
    ResultComponent,
    DialogComponent
  ],
  imports: [
    BrowserModule,
    AppRoutingModule,
    BrowserAnimationsModule,
    HttpClientModule,
    MatDialogModule
  ],
  providers: [{
    provide: APP_INITIALIZER,
    useFactory: getAllResults,
    deps: [DataService],
    multi: true
  },
  
  {provide: APP_INITIALIZER,
    useFactory: getNewbick,
    deps: [DataService],
    multi: true}
  ],
  bootstrap: [AppComponent]
})
export class AppModule { }

export function getAllResults(provider: DataService) {
  return () => provider.getAllResults();
}

export function getNewbick(provider: DataService) {
  return () => provider.getNewbick();
}

