import {Component, Inject} from '@angular/core';
import {MatDialog,MatDialogRef, MAT_DIALOG_DATA} from '@angular/material/dialog';
import { Router } from '@angular/router';

/**
 * @title Dialog Overview
 */
@Component({
  selector: 'dialog-component',
  templateUrl: './dialog.component.html',
})
export class DialogComponent {

  constructor(
    public dialogRef: MatDialogRef<DialogComponent>,
    @Inject(MAT_DIALOG_DATA) public data: any,private router: Router) {}
  
  //Cierra el cuadro de dialogo
  onNoClick(): void {
    this.dialogRef.close();
  }
  //Redirige a la familia y cierra el cuadro de dialogo
  goToFamily(family): void {
    this.dialogRef.close();
    this.router.navigate(['family/' + family]);
  }

}