import {Component, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { SpeciesAnalysis } from 'src/app/models/SpeciesAnalysis';
import { DataService } from 'src/app/services/data.service';
import { SearchService } from 'src/app/services/search.service';
@Component({
  selector: 'slf-family',
  templateUrl: './family.component.html',
  styleUrls: ['./family.component.scss']
})
export class FamilyComponent implements OnInit {
  results:any=[];       //Almacena los diferentes resultados de la especie seleccionada
  select_species:any=[] //Almacena las diferentes especies de la familia seleccionada
  id:string|null=null;  //Almacena el id de la familia (el nombre) que viene en al url
  species_analysis_map = new Map<string,Map<string,SpeciesAnalysis>>(); //Mapa de todos los resultados que hay en la base de datos
  search_service: SearchService; //Inserta las funciones necesarias para la búsqueda
  actual_specie:string="" //Almacena la especie actual que se está mostrando

  constructor(private dataService: DataService,private route: ActivatedRoute,public searchProvider: SearchService){
    this.species_analysis_map=dataService.species_analysis_map
    this.search_service=searchProvider
    }
    //Se lee de la url al familia y se renderiza la vista
    ngOnInit() {
      this.id = this.route.snapshot.paramMap.get('id');
      this.renderView()
    }

    //Renderiza la vista de familias
    renderView(){
      var cont=0;
      var cont1=0;
      var cont2=0;
      var primero=""
      var key_primero=""

      var checkIfCorrect=true
      ///Comprueba si la familia seleccioanda tiene datos, si no tiene datos no renderiza nada.
      try {
        this.species_analysis_map.get(this.id!)!.keys()
       }catch (error) {
        checkIfCorrect=false;
       }

       if(checkIfCorrect){

              for (let key of this.species_analysis_map.get(this.id!)!.keys()) {
                //Se extrae el nombre de la familia de cada especie
                let ini=key.indexOf(this.id!)

                if(cont==0){
                  primero=key.substring(0,ini-1)
                  key_primero=key
                }
                //Si la especie contiene el nombre de la familia se añade al select de especies
                if(!this.select_species.includes(key.substring(0,ini-1))){
                this.select_species[cont1]=key.substring(0,ini-1);
                cont1++;
                }

                cont++;
            }

            cont=0;
            //Inserta en resultados aquellos resultados que coinciden con la especie seleccioanda
            for (let key of this.species_analysis_map.get(this.id!)!.keys()) {
              if(key.includes(primero)){
                this.results[cont]=key;
                cont++;
              }
            }
            this.actual_specie=primero
          }


    }
    //Cambia a la vista de la especie seleccionada y muestra los resultados asociados a esa nueva especie
    changeSpecie(value){
      var cont=0
      for (let key of this.species_analysis_map.get(this.id!)!.keys()) {
        if(key.includes(value)){
          this.results[cont]=key;
          cont++;
        }
      }
      this.actual_specie=value
     }
}
