import { Component, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { SpeciesAnalysis } from 'src/app/models/SpeciesAnalysis';
import { DataService } from 'src/app/services/data.service';
import { SearchService } from 'src/app/services/search.service';

@Component({
  selector: 'slf-result',
  templateUrl: './result.component.html',
  styleUrls: ['./result.component.scss']
})
export class ResultComponent implements OnInit {
  species_analysis_map = new Map<string,Map<string,SpeciesAnalysis>>();
  search_service: SearchService;
  results:any={}
  family:string|null=null;
  id:string|null=null;
  select_results:any=[]
  constructor(private dataService: DataService,public searchService: SearchService,private route: ActivatedRoute) { 
    this.family = this.route.snapshot.paramMap.get('family');
    this.id = this.route.snapshot.paramMap.get('id');
    this.species_analysis_map=dataService.species_analysis_map
    this.search_service=searchService
    this.results=this.species_analysis_map.get(this.family!)?.get(this.id!)
    var cont1=0;
    let ini=this.id?.indexOf(this.family!)
    var specie=this.id!.substring(0,ini!-1)
    //Busca los resultados que coinciden con la especie dada
    for (let key of this.species_analysis_map.get(this.family!)!.keys()) {
      if(key.includes(specie)){
        this.select_results[cont1]=key
        cont1++;
        }
    }


  }

  ngOnInit(): void {
  }
  //Cambia entre los resultados de una misma especie
  changeResult(value){
    this.id=value
    this.results=this.species_analysis_map.get(this.family!)?.get(value)
   }

}
