import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { RegionTreeDistance } from 'src/app/models/RegionTreeDistance';
import { RegionModelAnalysis } from 'src/app/models/RegionModelAnalysis';
import { ModelAnalysis } from 'src/app/models/ModelAnalysis';
import { RegionAnalysis } from 'src/app/models/RegionAnalysis';
import { SpeciesAnalysis } from 'src/app/models/SpeciesAnalysis';
@Injectable({
  providedIn: 'root'
})
export class DataService {
species_analysis_map = new Map<string,Map<string,SpeciesAnalysis>>();
newbick:string=""
  constructor(private http: HttpClient) {}

  //Le el nombre de las familias de los directorios para crear el texto formateado
  getNewbick() {
    return this.http.get("http://localhost:5000/getfamilies").toPromise().then((res: any) => {
    this.newbick=res.newbick
    });
  }

  //Lee todos los datos almacenados en las carpetas
  getAllResults() {
    return this.http.get("http://localhost:5000/getresults").toPromise().then((res: any) => {
     
      let families_map = new Map<string,Map<string,SpeciesAnalysis>>();

        for (var aux in res.all_results) {

          var family               = res.all_results[aux].family
          let species_analysis_map = new Map<string,SpeciesAnalysis>();

          for (var aux1 in res.all_results[aux].results) {

           var cont_num_region_analysis=0
           var list_region_analysis:RegionAnalysis[]=[]

           for (var aux2 in res.all_results[aux].results[aux1].region_analysis) {

            var region_analysis = new RegionAnalysis("",[])
            var list_model_analysis:ModelAnalysis[]=[]
            var cont_num_model_analysis=0

            for (var aux3 in res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis) {
  
              var predicted      = new RegionModelAnalysis([],[],0,"null","","")
              var putative       = new RegionModelAnalysis([],[],0,"null","","")
              var model_analysis = new ModelAnalysis("",predicted,putative)
  
              ///SE LEEN LOS DATOS DE PREDICTED
              if(res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis[aux3].predicted!=="null"){

                var predicted_isoelectric_points:number[]=[]
                var predicted_min_tree_distances:RegionTreeDistance[]=[]
                var cont=0

                for (var aux4 in res.all_results[aux].results[aux1].region_analysis[aux2].
                  model_analysis[aux3].predicted.isoelectric_points) {

                  var iso=res.all_results[aux].results[aux1].region_analysis[aux2].
                  model_analysis[aux3].predicted.isoelectric_points[aux4]

                  predicted_isoelectric_points[cont]=iso
                  cont++
                }
                cont=0
                for (var aux5 in res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis[aux3].
                  predicted.min_tree_distances) {

                  var obj=res.all_results[aux].results[aux1].region_analysis[aux2].
                  model_analysis[aux3].predicted.min_tree_distances[aux5]

                  var region_tree_distance=new RegionTreeDistance(obj.region,obj.region_sequence,
                    obj.positive_best_sequence,obj.positive_min,obj.negative_best_sequence,obj.negative_min,obj.score)
                  predicted_min_tree_distances[cont]=region_tree_distance

                  cont++
                }
                  predicted = new RegionModelAnalysis(
                  predicted_min_tree_distances,
                  predicted_isoelectric_points,
                  res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis[aux3].predicted.genes_in_region,
                  res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis[aux3].predicted.model_fasta_path,
                  res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis[aux3].predicted.region_pdf_path,
                  res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis[aux3].predicted.phylogeny_tree_path)
              }
  
              ///SE LEEN LOS DATOS DE PUTATIVE
              if(res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis[aux3].putative!=="null"){
                var putative_isoelectric_points:number[]=[]
                var putative_min_tree_distances:RegionTreeDistance[]=[]
                var cont=0
                for (var aux4 in res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis[aux3].putative.isoelectric_points) {
                  var iso=res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis[aux3].putative.isoelectric_points[aux4]
                  putative_isoelectric_points[cont]=iso
                  cont++
                }
                cont=0
                for (var aux5 in res.all_results[aux].results[aux1].region_analysis[aux2].
                  model_analysis[aux3].putative.min_tree_distances) {

                  var obj=res.all_results[aux].results[aux1].region_analysis[aux2].
                  model_analysis[aux3].putative.min_tree_distances[aux5]

                  var region_tree_distance=new RegionTreeDistance(
                    obj.region,
                    obj.region_sequence,
                    obj.positive_best_sequence,
                    obj.positive_min,obj.negative_best_sequence,
                    obj.negative_min,obj.score)

                    putative_min_tree_distances[cont]=region_tree_distance
                  cont++
                }
                  putative = new RegionModelAnalysis(putative_min_tree_distances,
                  putative_isoelectric_points,
                  res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis[aux3].putative.genes_in_region,
                  res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis[aux3].putative.model_fasta_path,
                  res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis[aux3].putative.region_pdf_path,
                  res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis[aux3].putative.phylogeny_tree_path)
              }
  
              var model_analysis=new ModelAnalysis(
                res.all_results[aux].results[aux1].region_analysis[aux2].model_analysis[aux3].model_name,
                predicted,
                putative)
                
              list_model_analysis[cont_num_model_analysis]=model_analysis
              cont_num_model_analysis++
            }

            region_analysis=new RegionAnalysis(
            res.all_results[aux].results[aux1].region_analysis[aux2].region_name,
            list_model_analysis)

            list_region_analysis[cont_num_region_analysis]=region_analysis
            cont_num_region_analysis++
           }

           var species_analysis=new SpeciesAnalysis(
            res.all_results[aux].results[aux1].species_name,
            res.all_results[aux].results[aux1].predicted_skp1,
            res.all_results[aux].results[aux1].putative_skp1,
            res.all_results[aux].results[aux1].predicted_skp1_tree_path,
            res.all_results[aux].results[aux1].putative_skp1_tree_path,
            list_region_analysis)

            species_analysis_map.set(species_analysis.species_name,species_analysis)
          }
          families_map.set(family,species_analysis_map)
        }
        this.species_analysis_map=families_map
    });
  }
}
